% 1d Perona Malik Template Code
% you will need to fill in the ???

%create signal
size = 201;
f = zeros(1,size);
gamma = 15;
f(51-gamma:51+gamma)=1;
f(100:150) = (1/50)*([100:150]-100);

%for plotting later
mx = length(f);
x = [0:mx-1];

%add noise
rng('default');
%rng('shuffle');
sigma = 0.05;
fn = f + 0 + sigma*randn(1,mx);

delta = 0.001; %regularization for singular denominators
Alpha = 500; %parameter for edge detector function
p=2; %power for edge detector

%gaussian for edge detector
Sigma = 0.5; %stdv for gaussian convolution
X = linspace(-size / 2, size / 2, size);
GF = exp(-X.^2/(2*(Sigma^2))); %create gaussian
GF = GF/(sum(GF)); %normalize
fnfilt = conv(fn,GF,'same'); %convolution i.e. averaging filter with gaussian and signal

%edge detector
g = @(Alpha,p,U) 1./(1+Alpha*(conv(U,GF,'same').^p));

N=20000; %timesteps
dt = 0.001; %step size
u = fn; %initial image

%plot the initial image
figure(1)
plot(x,fn)
axis([0 mx -0.4 1.4])
pause

for i=1:N
   %perona malik
   ux = fdiff_nb_1d(??);
   abs_ux = abs(??);
   term = bdiff_nb_1d(g(Alpha,p,???).*???);
   u = u + dt*(???);
   
   if rem(i,500)==0
   %plot(u(3,3:my-2));
   plot(x,fn,x,u)
   axis([0 mx -0.4 1.4])
   pause
   end
end